=== debian/changelog ===
ros-r2b3-fastcdr (1.0.7-1xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Wed, 13 Sep 2017 23:29:12 -0000
